%define section free
%define base_version 3.0
%define main_version 3.0.5
%define hname hibernate

Summary:        Relational persistence and query service
Name:           %{hname}3
Version:        %{main_version}
Release:        1jpp
Epoch:          0
License:        LGPL
URL:            http://www.hibernate.org/
Group:          Database
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        hibernate-3.0.5.tar.gz
Patch0:         hibernate-build_xml.patch


BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  java-devel >= 0:1.4
BuildRequires:  junit
BuildRequires:  ant
BuildRequires:  ant-antlr
BuildRequires:  ant-junit
BuildRequires:  ant-swing
BuildRequires:  asm
BuildRequires:  c3p0
BuildRequires:  cglib >= 0:2.0
BuildRequires:  clover10
BuildRequires:  concurrent
BuildRequires:  jakarta-commons-collections >= 0:2.1
BuildRequires:  jakarta-commons-logging
BuildRequires:  jgroups
BuildRequires:  hsqldb >= 0:1.72
BuildRequires:  dom4j 
BuildRequires:  jaxen >= 0:1.1
BuildRequires:  j2ee-connector
BuildRequires:  jaas
BuildRequires:  jacc
BuildRequires:  jdbc-stdext
BuildRequires:  jta
BuildRequires:  log4j
#BuildRequires:  ehcache-bootstrap >= 0:3.0.5
BuildRequires:  oscache
BuildRequires:  proxool
BuildRequires:  swarmcache
BuildRequires:  jboss4-cache >= 0:4.0.2
BuildRequires:  jboss4-common >= 0:4.0.2
BuildRequires:  jboss4-jmx >= 0:4.0.2
BuildRequires:  jboss4-system >= 0:4.0.2
BuildRequires:  jaxp_parser_impl
BuildRequires:  xml-commons-apis
Requires:  java >= 0:1.4
Requires:  hibernate_jdbc_cache
Requires:  hibernate_in_process_cache	
Requires:  cglib >= 0:2.0
Requires:  jakarta-commons-collections >= 0:2.1
Requires:  jakarta-commons-logging
Requires:  dom4j
Requires:  jdbc-stdext
Requires:  jta
Requires:  xml-commons-apis
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Hibernate is a powerful, ultra-high performance 
object/relational persistence and query service 
for Java. Hibernate lets you develop persistent 
objects following common Java idiom - including 
association, inheritance, polymorphism, composition 
and the Java collections framework. Extremely 
fine-grained, richly typed object models are 
possible. The Hibernate Query Language, designed 
as a "minimal" object-oriented extension to SQL, 
provides an elegant bridge between the object and 
relational worlds. Hibernate is now the most 
popular ORM solution for Java.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
Javadoc for %{name}.

%prep
%setup -q -n %{hname}-%{base_version}
# remove all binary libs
find . -name "*.jar" -exec mv {} {}.no \;

%patch0 -b .sav

%build
export OPT_JAR_LIST="ant/ant-swing ant/ant-antlr antlr ant/ant-junit junit ant-launcher"
###BUILD/hibernate-3.0/lib/cleanimports.jar.no
###BUILD/hibernate-3.0/lib/versioncheck.jar.no
build-jar-repository -s -p lib \
ant \
ant/ant-antlr \
ant/ant-junit \
ant/ant-swing \
ant-launcher \
antlr \
asm/asm \
asm/asm-attrs \
c3p0 \
cglib \
commons-collections \
commons-logging \
concurrent \
dom4j \
ehcache \
hsqldb \
j2ee-connector \
jaas \
jacc \
jaxen \
jboss4/jboss-cache \
jboss4/jboss-common \
jboss4/jboss-jmx \
jboss4/jboss-system \
jdbc-stdext \
jgroups \
jta \
junit \
log4j \
oscache \
proxool \
swarmcache \
xerces-j2 \
xml-commons-apis \


CLASSPATH=$CLASSPATH:build/classes:build/testclasses:etc
ant jar extras junitreport javadoc 

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p dist/%{name}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
cp -p etc/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf doc/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar
%{_datadir}/%{name}-%{version}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%changelog
* Fri Aug 05 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.0.5-1jpp
- change name to hibernate3 and upgrade to 3.0.5

* Mon Sep 13 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.6-1jpp
- Drop saxpath requirements
- Require jaxen >= 0:1.1
- Upgrade to 2.1.6
- Activate clover task (clover10)

* Wed Aug 25 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-4jpp
- Build with ant-1.6.2
- Drop ant-optional BuildReq
- Relax some versioned dependencies

* Thu Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-3jpp
- Relax some versioned build dependencies 
- Reduce runtime dependencies
- Require hibernate_in_process_cache and hibernate_jdbc_cache at runtime

* Thu Jun 17 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-2jpp
- Try avoid symlinking into lib

* Tue Jun 08 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1.4-1jpp
- First JPackage release
